"""
* Copyright (C) 2004-2016 Brocade Communications Systems, Inc.  
"""

""" Check the version
"""

import sys
if sys.version_info < (2,7,6):
    print( 'Need python version 2.7.6 or later.')
    exit(1)

""" Import the modules
"""

from stage.ArgP import *
from stage.SanityChecker import *
from stage.ManifestParser import *
from stage.Installer import *
from stage.Copier import *
from stage.SignatureValidator import *
from stage.Cleaner import *
from stage.Summary import *
from data.ConfigData import *
from data.OperationalStateData import *
from session.SSHSession import *
from session.TELNETSession import *

""" Global Data
"""

config = ConfigData()
state = OperationalStateData()

""" Set up Logging
"""
import logging

state.logging = logging.getLogger("sbsupgrd.py")

# Console Handler
ch = logging.StreamHandler()
ch.setLevel(logging.DEBUG)

# Formatter
formatter = logging.Formatter(
                '%(asctime)s - %(name)s - %(levelname)s - %(message)s')
ch.setFormatter(formatter)

state.logging.setLevel(logging.INFO)
state.logging.addHandler(ch)

state.logging.debug("Started Logging")


cleanerMessage = """
Files, and directories that may have been created during the Copier Stage,
on compact flash, may be deleted by issuing the Cleaner stage as follows:

python sbsupgrd.py --device <DEVICE> --manifest <MANIFEST> --cf <CF> \
    --subdir <SUBDIR> --user <USER> --stage Cleaner

"""


try:

    m = None
    c = None
    sv = None
    i = None
    cl = None

    a = ArgP(config, state)
    a.run()

    if (config.verbose >= 1):
        state.logging.setLevel(logging.DEBUG)

    s = SanityChecker(config, state)
    s.run()

    if (config.stage == None or config.stage != "SanityChecker"):
        m = ManifestParser(config, state)
        m.run()

    if (config.stage == None or config.stage == "Copier"):
        c = Copier(config, state)
        c.run()

    if (config.stage == None or config.stage == "SignatureValidator"):
        sv = SignatureValidator(config, state)
        sv.run()

    if (config.stage == None or config.stage == "Installer"):
        i = Installer(config, state)
        i.run()

    if (config.stage == "Cleaner"):
        cl = Cleaner(config, state)
        cl.run()

except:

    if c != None:
        print ( cleanerMessage)
    print ( "Errors Occurred")

else:

    if c != None:
        print ( cleanerMessage)
    print ( "Success")


