"""session is a module to abstract different kinds of CLI sessions(
including TELNET and SSH) to a device. 

* Copyright (C) 2004-2016 Brocade Communications Systems, Inc.  

"""

try:
    import pexpect
except ImportError:  # pragma: no cover
    import sys
    err = sys.exc_info()[1]
    raise ImportError(str(err) + """

pexpect module missing!
Please install module.""")

__all__ = ['ExceptionSession', 'SSHSession', 'TELNETSession']
__version__ = '0.1'
__revision__ = ''

class ExceptionSession(pexpect.ExceptionPexpect):
    """Base class for all exceptions raised by this module.
    """

    def __init__(self, value):
        super(ExceptionSession, self).__init__(value)
        self.value = value

    def __str__(self):
        return str(self.value)

