"""
* Copyright (C) 2004-2016 Brocade Communications Systems, Inc.  
"""

from stage.Stage import *
from session import *
import sys
import re
import pexpect

class Cleaner(Stage):
    """ Cleaner
    """

    def __init__(self, config, state):
        """This is the constructor.
        """
        super(Cleaner, self).__init__(config, state)

    def run(self):
        """ Run this stage: 1. Remove Files 2. Remove Directory(SESSION)
        """

        self.state.logging.info('Stage: Cleaner: Started')

        self.make_connection()

        self.remove_files()

        self.remove_directories()

        self.break_connection()

    def remove_directories(self):
        """Remove Directories
        """

        dirs = [ \
            "Boot/InterfaceModule", \
            "Boot/ManagementModule", \
            "Boot", \
            "Combined/FPGA", \
            "Combined/Application", \
            "Combined", \
            "Monitor/InterfaceModule", \
            "Monitor/ManagementModule", \
            "Monitor", \
            "Application/InterfaceModule", \
            "Application/ManagementModule", \
            "Application", \
            "FPGA/InterfaceModule", \
            "FPGA/ManagementModule", \
            "FPGA", \
            "Signatures", \
        ]
 
        subdir = '/' + self.config.cf
        if self.config.subdir != "" :
            subdir = subdir + '/' + self.config.subdir
        maindir = subdir
        subdir = subdir + self.slash_xmr_mlx
        mainsubdir = subdir


        for dir in dirs:
            self.rmdir(mainsubdir + '/' + dir)

        self.rmdir(mainsubdir)
        if self.config.subdir != "" :
            self.rmdir(maindir)

    def rmdir(self,dir):
        self.state.logging.info(
                    'Stage: Cleaner: rmdir ' + dir)
        self.state.session.sendline('rmdir ' + dir)
        self.state.session.prompt()

    def remove_files(self):
        """Remove files
        """

        r = re.match(r'(.)*/', self.config.manifest)
        src = r.group(0)

        if self.config.subdir != "" :
            subdir = self.config.subdir + self.slash_xmr_mlx
        else:
            subdir = self.xmr_mlx

        for (dir,file) in self.state.filelist:

            command = 'rm /' + self.config.cf + '/' + subdir + dir + '/' + file
            self.state.logging.info('Stage: Cleaner: ' + command)

            self.state.session.sendline(command)
            self.state.session.prompt()

