"""
* Copyright (C) 2004-2016 Brocade Communications Systems, Inc.  
"""

from stage.Stage import *
from session import *
import sys
import re
import pexpect
import os

class Installer(Stage):
    """ Installer
    """

    def __init__(self, config, state):
        """This is the constructor.
        """
        super(Installer, self).__init__(config, state)

        self.error = 0

    def run(self):
        """ Run this stage: 
        """

        try: 
            self.state.logging.info('Stage: Installer: Started')

            self.make_connection()

            self.issue_copy_command()

            self.break_connection()
        except:
            self.state.logging.error( 'Stage: Installer: Error')
            self.error = 1
        finally:
            if self.error:
                exit(6)

    def issue_copy_command(self):
        """Issue Copy Command
        """

        self.state.logging.info('Stage: Installer: Copy Command')

#        r = re.match(r'(.)*/(XMR-MLX.*)', self.config.manifest)
#        manifest_file = r.group(2)

        manifest_file = os.path.basename(self.config.manifest)

        command = "copy " + self.config.cf + " system manifest "

        if self.config.subdir != "":
            command = command + self.config.subdir + "/"

        command = command + self.xmr_mlx + "/" + manifest_file

        self.state.logging.info(
                    'Stage: Installer: ' + command)

        self.state.session.prompt(self.prompt_timeout)
        self.state.session.sendline(command)
        self.state.session.prompt(self.prompt_copy_timeout)

        self.state.logging.info('Stage: Installer: **************************')
        self.state.logging.info('Note: Please check device logs to ensure all')
        self.state.logging.info('is in order prior to reloading the system')
        self.state.logging.info('Stage: Installer: **************************')

