"""
* Copyright (C) 2004-2016 Brocade Communications Systems, Inc.  
"""

from stage.Stage import *
from session import *
import sys
import pexpect
import re

class ManifestParser(Stage):
    """ Manifest Parser
    """

    def __init__(self, config, state):
        """This is the constructor.
        """
        super(ManifestParser, self).__init__(config, state)

    def run(self):
        """ Run this stage: Setup the session, and test.
        """

        self.state.logging.info('Stage: Manifest Parser: Started')

        self.state.manifest = self.config.manifest

        self.state.logging.info('Stage: Manifest Parser: Opening ' + \
            str(self.state.manifest))

        f = open(self.state.manifest, 'r')

        skip = False
        parsing_files = True
        parsing_signatures = False
        directory = None
        file = None
        self.state.filelist = []

        for line in f:
#            self.state.logging.debug('Stage: Manifest Parser: Line: ' + \
#                str(line))
            
            if line[0:8] == "#  MIBS:":
                skip = True
            elif line[0] == '#':
                pass
            elif line[0:21] == "-NETIRON_IRONWARE_VER":
                pass
            elif line[0:10] == "-DIRECTORY":
                directory = line[11:-2]
                self.state.logging.debug('Stage: Manifest Parser: Dir: ' + \
                    directory)
            elif line[0:14] == "-END_OF_IMAGES":
                parsing_files = False
                parsing_signatures = True
            elif re.match(r'\s', line):
                pass
            else:
                r = re.match(r'\S+', line[0:-2])
                file = r.group()
                if directory == "":
                    pass
                elif skip:
                    continue
                self.state.logging.debug('Stage: Manifest Parser: File: ' + \
                    file)
                self.state.filelist.append((directory, file))

        f.close()

        self.state.logging.info('Stage: Manifest Parser: Closed' + \
            str(self.state.manifest))

        self.state.logging.debug('Stage: Manifest Parser: List:')

        for (directory, file) in self.state.filelist:
            self.state.logging.debug('           ( ' + \
                    directory + ' , ' + file + ' )' )
            


#        try: 
#            if self.state.session is None:
#                self.state.logging.info(
#                    'Stage: Sanity Checker: Session inactive')
#                self.state.session = SSHSession.SSHSession(self.config, self.state)
#                self.state.session.connect()
#
#                self.get_device_info()
#
#                self.state.session.disconnect()
#                self.state.session = None
#
#            else:
#                self.state.logging.warning(
#                    'Stage: Sanity Checker: Session already active')
#
#        except:
#            self.state.logging.error( 'Stage: Sanity Checker: Error')
#            raise
# 
#
#    def get_device_info(self):
#        """Get the device information
#        """
#
#        self.state.session.sendline('show ver | i processor')
#        index = self.state.session.expect_exact(
#            ['processor 8544', 'processor 7448',
#            pexpect.EOF, pexpect.TIMEOUT])
#
#        if index == 0:
#            self.state.logging.info( 'Stage: Sanity Checker: Device: CES/CER')
#            self.state.device_type = self.state.CES_CER
#        elif index == 1:
#            self.state.logging.info( 'Stage: Sanity Checker: Device: XMR/MLX')
#            self.state.device_type = self.state.XMR_MLX
#        elif index == 2: 
#            self.state.logging.error(
#                'Stage: Sanity Checker: Unknown Device(eof)')
#        elif index == 3:
#            self.state.logging.error(
#                'Stage: Sanity Checker: Unknown Device(timeout)')
#
